(* Lacaml を使った手軽な代数方程式の解の計算 *)

open Format
open Bigarray

open Lacaml.D
open Lacaml.Io

let k = 1.
let m = 1.

(* x^3 - 3x + 1 = 0 *)
let modal_mat = [|
  [| 0.; 1.; 0. |];
  [| 0.; 0.; 1. |];
  [|-1.; 3.; 0. |]
|]

(* 固有ベクトルの計算 *)
let eigen_values a_mat =
  let a = Mat.of_array a_mat in
  let a_copy = lacpy a in
  geev a_copy

(* 使用例  *)
let () =
  let (lm,wr,wi,rv) = eigen_values modal_mat in
  let w = Vec.to_array wr in
  Array.iter (fun elm -> print_endline (string_of_float elm)) w
 
